function [ w ] = fit_logistic_regression( X, y, lambda, theta_init )
%FIT_LOGISTIC_REGRESSION Fast implementation of logistic regression
% Inputs:
%  X       - training data (N x d). Should include a column of ones
%  y       - labels (d x 1)
%  lambda  - regularization parameter
%
% Output:
%  w       - fitted weight vector

fprintf('Fitting model\n');
f = @(theta) regularized_cost_function(theta, X, y, lambda); % anonymous function handle
w = fmincg (f, theta_init);                  % minimize f by method of conjugate gradients

end
