function [ weight_vectors ] = one_vs_all(X, y, num_classes, lambda)
% ONE_VS_ALL Train a multi-class logistic regression model using the
%            one-vs-all strategy.
%
% Inputs: 
%   X           - training data (m x n matrix)
%   y           - class labels (m x 1 vector, with entries from 1 to 10)
%   num_classes - the number of classes
%   lambda      - the regularization parameter (how much to penalize the weights)
%
% Outputs:
%   weight_vectors - a matrix of size (n+1) x num_classes, whose columns
%                    contain the weight vectors. I.e., weight_vectors(:,c)
%                    should be the weight vector for distinguishing
%                    class c from the rest.

% Get the relevant sizes
[m,n] = size(X);

% Add column of ones
X = [ones(m,1) X];

% Initialize weight vectors
weight_vectors = zeros(n+1, num_classes);

% YOUR CODE HERE
