function predictions = predict_one_vs_all(weight_vectors, X)
% PREDICT_ONE_VS_ALL Make predictions using a one-vs-all logistic
%                    regression model
%
% Inputs:
%   weight_vectors - Size (n+1) x K, where K = # of classes.
%                    Column c is the weight vector for class c
%   X              - Size m x n. 
%                    The test examples. Remember that each row of X is an
%                    example.
%
% Output:
%
%   predictions - Size m x 1. The ith entry should be a number between 1
%                 and K that indicates the class we predict (just like the
%                 vector y used for training)

m = size(X, 1);
num_classes = size(weight_vectors, 2);

% Initialize the return variable 
predictions = zeros(m, 1);

% Add ones to the X data matrix
X = [ones(m,1) X];

% Write your code below!
%  
%  Hint: This computation can be vectorized efficiently and done in just
%        a few lines. You need to compute inner products between each
%        example (row of X) and each weight vector (column of
%        weight_vectors). Think about how this can be done by matrix-matrix
%        multiplication.
%        
%        Recall that the max() function can be called to find the maximum of 
%        each column of a matrix. Read the documentation to learn more.


end
