load digits.mat; % Imports X_train, y_train, X_test, y_test into your MATLAB environment

lambda = .001;
num_classes = 10; 
[weight_vectors] = one_vs_all(X_train, y_train, num_classes, lambda);

pred_train = predict_one_vs_all(weight_vectors, X_train);
pred_test  = predict_one_vs_all(weight_vectors, X_test);

fprintf('\nTraining Set Accuracy: %f\n', mean(pred_train == y_train) * 100);
fprintf(  '    Test Set Accuracy: %f\n', mean(pred_test  == y_test)  * 100);

% Visualize the weight vectors as images
%   - Drop the intercept term, which is the first of each weight vector
%   - Also, our weight vectors are in columns, but display_data() wants the 
%     images to be in rows, so we need to transpose first.
%
display_data( weight_vectors(2:end,:)' );