
load digits2.mat; % Imports X_train, y_train, X_test, y_test into your MATLAB environment
%
% NOTE: This is the same data, but this time it is split into 2500 training 
%       examples and 2500 test examples.
%

% Constants
num_classes = 10;
lambda = .001;
m = size(X_train, 1);

% ---------------------------------------------------------------------
% EXAMPLE:
%
% Below is an example to train a model on only 250 training examples. 
% You should modify/replace this with your code, which will train many 
% different models on subsets of increasing size.

p = randperm(m); % a random permutation of the indices 1:N

rows = p(1:250); % the first 250 random indices

X_small = X_train(rows,:);  % grab the corresponding rows of X_train
y_small = y_train(rows);    % and the corresponding entries of y_train

[weight_vectors] = one_vs_all(X_small, y_small, num_classes, lambda);

pred_small = predict_one_vs_all(weight_vectors, X_small);
pred_test  = predict_one_vs_all(weight_vectors, X_test);

fprintf('\nTraining Set Accuracy: %f\n', mean(pred_small == y_small) * 100);
fprintf(  '    Test Set Accuracy: %f\n', mean(pred_test  == y_test)  * 100);

% ---------------------------------------------------------------------

% Use these training sizes for your experiment 
train_sizes = (250:250:2500)';


